package org.icroco.tablemodel.blinking;

/**
 * EBlinkingMode.
 * 
 * @author ouaibsky - 22 avr. 2009
 * 
 */
public enum EBlinkingMode
{
	/**
	 * FONT design flash mode which play with font modification.
	 */
	FONT,
	/**
	 * BORDER design flash mode which play with border highlight.
	 */
	BORDER,
	/**
	 * COLOR design flash mode which play with background and/or foreground.
	 */
	COLOR,
	/**
	 * COLOR design flash mode which play with animated background color (and/or fixed foreground color).
	 */
	ANIMATED_BG_COLOR,

	/**
	 * DEFAULT is just a technical hook to detect unset parameter annotation for {@link ABlinking#mode()}.
	 * When we find DEFAULT we replace by default {@value #COLOR}. You should not used
	 * this value.
	 */
	DEFAULT

}
